Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -2234,7 +2914,9 @@
                         $conv = \%newConv;
                     }
+                    undef $evalWarning;
                     if ($$conv{BITMASK}) {
                         my $lookupBits = $$conv{BITMASK};
-                        my ($val2, $err2) = EncodeBits($val, $lookupBits);
+                        my ($wbits, $tbits) = @$tagInfo{'BitsPerWord','BitsTotal'};
+                        my ($val2, $err2) = EncodeBits($val, $lookupBits, $wbits, $tbits);
                         if ($err2) {
                             # ok, try matching a straight value
@@ -2255,9 +2937,11 @@
                         ($val, $multi) = ReverseLookup($val, $conv);
                     }
-                    unless (defined $val) {
-                        $err = "Can't convert $wgrp1:$tag (" .
-                               ($multi ? 'matches more than one' : 'not in') . " $type)";
+                    if (not defined $val) {
+                        my $prob = $evalWarning ? lcfirst CleanWarning() : ($multi ? 'matches more than one ' : 'not in ') . $type;
+                        $err = "Can't convert $wgrp1:$tag ($prob)";
                         $self->VPrint(2, "$err\n");
                         last Conv;
+                    } elsif ($evalWarning) {
+                        $self->VPrint(2, CleanWarning() . " for $wgrp1:$tag\n");
                     }
                 } elsif (not $$tagInfo{WriteAlso}) {
@@ -2285,5 +2969,6 @@
 
 #------------------------------------------------------------------------------
-# convert tag names to values in a string (ie. "${EXIF:ISO}x $$" --> "100x $")
+# Convert tag names to values or variables in a string
+# (eg. '${EXIF:ISO}x $$' --> '100x $' without hash ref, or "$info{'EXIF:ISO'}x $" with)
 # Inputs: 0) ExifTool object ref, 1) reference to list of found tags
 #         2) string with embedded tag names, 3) Options:
@@ -2291,25 +2976,44 @@
 #              'Error'   - issue minor error on missing tag (and return undef)
 #              'Warn'    - issue minor warning on missing tag (and return undef)
-#               Hash ref - hash for return of tag/value pairs
+#              'Silent'  - just return undef on missing tag (no errors/warnings)
+#               Hash ref - defined to interpolate as variables in string instead of values
+#                          --> receives tag/value pairs for interpolation of the variables
+#         4) document group name if extracting from a specific document
+#         5) hash ref to cache tag keys for subsequent calls in document loop
 # Returns: string with embedded tag values (or '$info{TAGNAME}' entries with Hash ref option)
 # Notes:
 # - tag names are not case sensitive and may end with '#' for ValueConv value
 # - uses MissingTagValue option if set
-sub InsertTagValues($$$;$)
-{
-    my ($self, $foundTags, $line, $opt) = @_;
+# - '$GROUP:all' evaluates to 1 if any tag from GROUP exists, or 0 otherwise
+# - advanced feature allows Perl expressions inside braces (eg. '${model;tr/ //d}')
+# - an error/warning in an advanced expression ("${TAG;EXPR}") generates an error
+#   if option set to 'Error', or a warning otherwise
+sub InsertTagValues($$$;$$$)
+{
+    local $_;
+    my ($self, $foundTags, $line, $opt, $docGrp, $cache) = @_;
     my $rtnStr = '';
-    while ($line =~ /(.*?)\$(\{?)([-\w]+|\$|\/)(.*)/s) {
-        my (@tags, $pre, $var, $bra, $val, $tg, @vals, $type);
-        ($pre, $bra, $var, $line) = ($1, $2, $3, $4);
+    my ($docNum, $tag);
+    if ($docGrp) {
+        $docNum = $docGrp =~ /(\d+)$/ ? $1 : 0;
+    } else {
+        undef $cache;   # no cache if no document groups
+    }
+    while ($line =~ s/(.*?)\$(\{\s*)?([-\w]*\w|\$|\/)//s) {
+        my ($pre, $bra, $var) = ($1, $2, $3);
+        my (@tags, $val, $tg, @val, $type, $expr, $didExpr, $level, $asList);
         # "$$" represents a "$" symbol, and "$/" is a newline
         if ($var eq '$' or $var eq '/') {
-            $var = "\n" if $var eq '/';
+            $line =~ s/^\s*\}// if $bra;
+            if ($var eq '/') {
+                $var = "\n";
+            } elsif ($line =~ /^self\b/ and not $rtnStr =~ /\$$/) {
+                $var = '$$';    # ("$$self{var}" in string)
+            }
             $rtnStr .= "$pre$var";
-            $line =~ s/^\}// if $bra;
             next;
         }
         # allow multiple group names
-        while ($line =~ /^:([-\w]+)(.*)/s) {
+        while ($line =~ /^:([-\w]*\w)(.*)/s) {
             my $group = $var;
             ($var, $line) = ($1, $2);
@@ -2318,65 +3022,183 @@
         # allow trailing '#' to indicate ValueConv value
         $type = 'ValueConv' if $line =~ s/^#//;
+        # special advanced formatting '@' feature to evaluate list values separately
+        if ($bra and $line =~ s/^\@(#)?//) {
+            $asList = 1;
+            $type = 'ValueConv' if $1;
+        }
         # remove trailing bracket if there was a leading one
-        $line =~ s/^\}// if $bra;
+        # and extract Perl expression from inside brackets if it exists
+        if ($bra and $line !~ s/^\s*\}// and $line =~ s/^\s*;\s*(.*?)\s*\}//s) {
+            my $part = $1;
+            $expr = '';
+            for ($level=0; ; --$level) {
+                # increase nesting level for each opening brace
+                ++$level while $part =~ /\{/g;
+                $expr .= $part;
+                last unless $level and $line =~ s/^(.*?)\s*\}//s; # get next part
+                $part = $1;
+                $expr .= '}';  # this brace was part of the expression
+            }
+            # use default Windows filename filter if expression is empty
+            $expr = 'tr(/\\\\?*:|"<>\\0)()d' unless length $expr;
+        }
         push @tags, $var;
         ExpandShortcuts(\@tags);
         @tags or $rtnStr .= $pre, next;
+        # save advanced formatting expression to allow access by user-defined ValueConv
+        $$self{FMT_EXPR} = $expr;
 
         for (;;) {
-            my $tag = shift @tags;
-            if ($tag =~ /(.*):(.+)/) {
+            # temporarily reset ListJoin option if evaluating list values separately
+            my $oldListJoin;
+            $oldListJoin = $self->Options(ListJoin => undef) if $asList;
+            $tag = shift @tags;
+            my $lcTag = lc $tag;
+            if ($cache and $lcTag !~ /(^|:)all$/) {
+                # remove group from tag name (but not lower-case version)
                 my $group;
-                ($group, $tag) = ($1, $2);
-                # find the specified tag
-                my @matches = grep /^$tag(\s|$)/i, @$foundTags;
-                @matches = $self->GroupMatches($group, \@matches);
-                foreach $tg (@matches) {
-                    if (defined $val and $tg =~ / \((\d+)\)$/) {
-                        # take the most recently extracted tag
-                        my $tagNum = $1;
-                        next if $tag !~ / \((\d+)\)$/ or $1 > $tagNum;
-                    }
-                    $val = $self->GetValue($tg, $type);
-                    $tag = $tg;
-                    last unless $tag =~ / /;    # all done if we got our best match
+                $tag =~ s/^(.*):// and $group = $1;
+                # cache tag keys to speed processing for a large number of sub-documents
+                # (similar to code in BuildCompositeTags(), but this is case-insensitive)
+                my $cacheTag = $$cache{$lcTag};
+                unless ($cacheTag) {
+                    $cacheTag = $$cache{$lcTag} = [ ];
+                    # find all matching keys, organize into groups, and store in cache
+                    my $ex = $$self{TAG_EXTRA};
+                    my @matches = grep /^$tag(\s|$)/i, @$foundTags;
+                    @matches = $self->GroupMatches($group, \@matches) if defined $group;
+                    foreach (@matches) {
+                        my $doc = $$ex{$_} ? $$ex{$_}{G3} || 0 : 0;
+                        if (defined $$cacheTag[$doc]) {
+                            next unless $$cacheTag[$doc] =~ / \((\d+)\)$/;
+                            my $cur = $1;
+                            # keep the most recently extracted tag
+                            next if / \((\d+)\)$/ and $1 < $cur;
+                        }
+                        $$cacheTag[$doc] = $_;
+                    }
+                }
+                my $doc = $lcTag =~ /\b(main|doc(\d+)):/ ? ($2 || 0) : $docNum;
+                if ($$cacheTag[$doc]) {
+                    $tag = $$cacheTag[$doc];
+                    $val = $self->GetValue($tag, $type);
                 }
             } else {
-                # get the tag value
-                $val = $self->GetValue($tag, $type);
-                unless (defined $val) {
-                    # check for tag name with different case
-                    ($tg) = grep /^$tag$/i, @$foundTags;
-                    if (defined $tg) {
-                        $val = $self->GetValue($tg, $type);
-                        $tag = $tg;
-                    }
-                }
-            }
+                # add document number to tag if specified and it doesn't already exist
+                if ($docGrp and $lcTag !~ /\b(main|doc\d+):/) {
+                    $tag = $docGrp . ':' . $tag;
+                    $lcTag = lc $tag;
+                }
+                if ($lcTag eq 'all') {
+                    $val = 1;   # always some tag available
+                } elsif (defined $$self{OPTIONS}{UserParam}{$lcTag}) {
+                    $val = $$self{OPTIONS}{UserParam}{$lcTag};
+                } elsif ($tag =~ /(.*):(.+)/) {
+                    my $group;
+                    ($group, $tag) = ($1, $2);
+                    if (lc $tag eq 'all') {
+                        # see if any tag from the specified group exists
+                        my $match = $self->GroupMatches($group, $foundTags);
+                        $val = $match ? 1 : 0;
+                    } else {
+                        # find the specified tag
+                        my @matches = grep /^$tag(\s|$)/i, @$foundTags;
+                        @matches = $self->GroupMatches($group, \@matches);
+                        foreach $tg (@matches) {
+                            if (defined $val and $tg =~ / \((\d+)\)$/) {
+                                # take the most recently extracted tag
+                                my $tagNum = $1;
+                                next if $tag !~ / \((\d+)\)$/ or $1 > $tagNum;
+                            }
+                            $val = $self->GetValue($tg, $type);
+                            $tag = $tg;
+                            last unless $tag =~ / /;    # all done if we got our best match
+                        }
+                    }
+                } elsif ($tag eq 'self') {
+                    $val = $self; # ("$self{var}" or "$self->{var}" in string)
+                } else {
+                    # get the tag value
+                    $val = $self->GetValue($tag, $type);
+                    unless (defined $val) {
+                        # check for tag name with different case
+                        ($tg) = grep /^$tag$/i, @$foundTags;
+                        if (defined $tg) {
+                            $val = $self->GetValue($tg, $type);
+                            $tag = $tg;
+                        }
+                    }
+                }
+            }
+            $self->Options(ListJoin => $oldListJoin) if $asList;
             if (ref $val eq 'ARRAY') {
-                $val = join($self->{OPTIONS}{ListSep}, @$val);
+                push @val, @$val;
+                undef $val;
+                last unless @tags;
             } elsif (ref $val eq 'SCALAR') {
-                if ($self->{OPTIONS}{Binary} or $$val =~ /^Binary data/) {
+                if ($$self{OPTIONS}{Binary} or $$val =~ /^Binary data/) {
                     $val = $$val;
                 } else {
                     $val = 'Binary data ' . length($$val) . ' bytes';
                 }
+            } elsif (ref $val eq 'HASH') {
+                require 'Image/ExifTool/XMPStruct.pl';
+                $val = Image::ExifTool::XMP::SerializeStruct($val);
             } elsif (not defined $val) {
-                last unless @tags;
-                next;
+                $val = $$self{OPTIONS}{MissingTagValue} if $asList;
             }
             last unless @tags;
-            push @vals, $val;
+            push @val, $val if defined $val;
             undef $val;
         }
-        if (@vals) {
-            push @vals, $val if defined $val;
-            $val = join '', @vals;
+        if (@val) {
+            push @val, $val if defined $val;
+            $val = join $$self{OPTIONS}{ListSep}, @val;
+        } else {
+            push @val, $val if defined $val; # (so the eval has access to @val if required)
+        }
+        # evaluate advanced formatting expression if given (eg. "${TAG;EXPR}")
+        if (defined $expr and defined $val) {
+            local $SIG{'__WARN__'} = \&SetWarning;
+            undef $evalWarning;
+            $advFmtSelf = $self;
+            if ($asList) {
+                foreach (@val) {
+                    #### eval advanced formatting expression ($_, $self, @val, $advFmtSelf)
+                    eval $expr;
+                    $@ and $evalWarning = $@;
+                }
+                # join back together if any values are still defined
+                @val = grep defined, @val;
+                $val = @val ? join $$self{OPTIONS}{ListSep}, @val : undef;
+            } else {
+                $_ = $val;
+                #### eval advanced formatting expression ($_, $self, @val, $advFmtSelf)
+                eval $expr;
+                $@ and $evalWarning = $@;
+                $val = ref $_ eq 'ARRAY' ? join($$self{OPTIONS}{ListSep}, @$_): $_;
+            }
+            if ($evalWarning) {
+                my $g3 = ($docGrp and $var !~ /\b(main|doc\d+):/i) ? $docGrp . ':' : '';
+                my $str = CleanWarning() . " for '$g3${var}'";
+                if ($opt) {
+                    if ($opt eq 'Error') {
+                        $self->Error($str);
+                    } elsif ($opt ne 'Silent') {
+                        $self->Warn($str);
+                    }
+                }
+            }
+            undef $advFmtSelf;
+            $didExpr = 1;   # set flag indicating an expression was evaluated
         }
         unless (defined $val or ref $opt) {
-            $val = $self->{OPTIONS}{MissingTagValue};
+            $val = $$self{OPTIONS}{MissingTagValue};
             unless (defined $val) {
+                my $g3 = ($docGrp and $var !~ /\b(main|doc\d+):/i) ? $docGrp . ':' : '';
+                my $msg = $didExpr ? "Advanced formatting expression returned undef for '$g3${var}'" :
+                                     "Tag '$g3${var}' not defined";
                 no strict 'refs';
-                return undef if $opt and &$opt($self, "Tag '$var' not defined", 1);
+                $opt and ($opt eq 'Silent' or &$opt($self, $msg, 2)) and return $$self{FMT_EXPR} = undef;
                 $val = '';
             }
@@ -2384,5 +3206,11 @@
         if (ref $opt eq 'HASH') {
             $var .= '#' if $type;
-            $rtnStr .= "$pre\$info{'$var'}";
+            if (defined $expr) {
+                # generate unique variable name for this modified tag value
+                my $i = 1;
+                ++$i while exists $$opt{"$var.expr$i"};
+                $var .= '.expr' . $i;
+            }
+            $rtnStr .= "$pre\$info{'${var}'}";
             $$opt{$var} = $val;
         } else {
@@ -2390,5 +3218,34 @@
         }
     }
+    $$self{FMT_EXPR} = undef;
     return $rtnStr . $line;
+}
+
+#------------------------------------------------------------------------------
+# Reformat date/time value in $_ based on specified format string
+# Inputs: 0) date/time format string
+sub DateFmt($)
+{
+    my $et = bless { OPTIONS => { DateFormat => shift, StrictDate => 1 } };
+    my $shift;
+    if ($advFmtSelf and defined($shift = $$advFmtSelf{OPTIONS}{GlobalTimeShift})) {
+        $$et{OPTIONS}{GlobalTimeShift} = $shift;
+        $$et{GLOBAL_TIME_OFFSET} = $$advFmtSelf{GLOBAL_TIME_OFFSET};
+    }
+    $_ = $et->ConvertDateTime($_);
+    defined $_ or warn "Error converting date/time\n";
+    $$advFmtSelf{GLOBAL_TIME_OFFSET} = $$et{GLOBAL_TIME_OFFSET} if $shift;
+}
+
+#------------------------------------------------------------------------------
+# Utility routine to remove duplicate items from default input string
+# Inputs: 0) true to set $_ to undef if not changed
+# Notes: - for use only in advanced formatting expressions
+sub NoDups
+{
+    my %seen;
+    my $sep = $advFmtSelf ? $$advFmtSelf{OPTIONS}{ListSep} : ', ';
+    my $new = join $sep, grep { !$seen{$_}++ } split /\Q$sep\E/, $_;
+    $_ = ($_[0] and $new eq $_) ? undef : $new;
 }
 
@@ -2408,10 +3265,13 @@
     my $tagInfo;
     foreach $tagInfo (@tagInfo) {
-        return 1 if $$tagInfo{Writable} or $tagInfo->{Table}{WRITABLE};
+        return $$tagInfo{Writable} ? 1 : 0 if defined $$tagInfo{Writable};
+        return 1 if $$tagInfo{Table}{WRITABLE};
         # must call WRITE_PROC to autoload writer because this may set the writable tag
-        my $writeProc = $tagInfo->{Table}{WRITE_PROC};
-        next unless $writeProc;
-        &$writeProc();  # dummy call to autoload writer
-        return 1 if $$tagInfo{Writable};
+        my $writeProc = $$tagInfo{Table}{WRITE_PROC};
+        if ($writeProc) {
+            no strict 'refs';
+            &$writeProc();  # dummy call to autoload writer
+            return 1 if $$tagInfo{Writable};
+        }
     }
     return 0;
@@ -2419,22 +3279,81 @@
 
 #------------------------------------------------------------------------------
+# Check to see if these are the same file
+# Inputs: 0) ExifTool ref, 1) first file name, 2) second file name
+# Returns: true if file names reference the same file
+sub IsSameFile($$$)
+{
+    my ($self, $file, $file2) = @_;
+    return 0 unless lc $file eq lc $file2;  # (only looking for differences in case)
+    my ($isSame, $interrupted);
+    my $tmp1 = "${file}_ExifTool_tmp_$$";
+    my $tmp2 = "${file2}_ExifTool_tmp_$$";
+    {
+        local *TMP1;
+        local $SIG{INT} = sub { $interrupted = 1 };
+        if ($self->Open(\*TMP1, $tmp1, '>')) {
+            close TMP1;
+            $isSame = 1 if $self->Exists($tmp2);
+            $self->Unlink($tmp1);
+        }
+    }
+    if ($interrupted and $SIG{INT}) {
+        no strict 'refs';
+        &{$SIG{INT}}();
+    }
+    return $isSame;
+}
+
+#------------------------------------------------------------------------------
+# Is this a raw file type?
+# Inputs: 0) ExifTool ref
+# Returns: true if FileType is a type of RAW image
+sub IsRawType($)
+{
+    my $self = shift;
+    return $rawType{$$self{FileType}};
+}
+
+#------------------------------------------------------------------------------
 # Create directory for specified file
-# Inputs: 0) complete file name including path
+# Inputs: 0) ExifTool ref, 1) complete file name including path
 # Returns: 1 = directory created, 0 = nothing done, -1 = error
-sub CreateDirectory($)
+my $k32CreateDir;
+sub CreateDirectory($$)
 {
     local $_;
-    my $file = shift;
+    my ($self, $file) = @_;
     my $rtnVal = 0;
+    my $enc = $$self{OPTIONS}{CharsetFileName};
     my $dir;
     ($dir = $file) =~ s/[^\/]*$//;  # remove filename from path specification
-    if ($dir and not -d $dir) {
+    # recode as UTF-8 if necessary
+    if ($dir and not $self->IsDirectory($dir)) {
         my @parts = split /\//, $dir;
         $dir = '';
         foreach (@parts) {
             $dir .= $_;
-            if (length $dir and not -d $dir) {
+            if (length $dir and not $self->IsDirectory($dir)) {
                 # create directory since it doesn't exist
-                mkdir($dir, 0777) or return -1;
+                my $d2 = $dir; # (must make a copy in case EncodeFileName recodes it)
+                if ($self->EncodeFileName($d2)) {
+                    # handle Windows Unicode directory names
+                    unless (eval { require Win32::API }) {
+                        $self->Warn('Install Win32::API to create directories with Unicode names');
+                        return -1;
+                    }
+                    unless ($k32CreateDir) {
+                        return -1 if defined $k32CreateDir;
+                        $k32CreateDir = new Win32::API('KERNEL32', 'CreateDirectoryW', 'PP', 'I');
+                        unless ($k32CreateDir) {
+                            $self->Warn('Error calling Win32::API::CreateDirectoryW');
+                            $k32CreateDir = 0;
+                            return -1;
+                        }
+                    }
+                    $k32CreateDir->Call($d2, 0) or return -1;
+                } else {
+                    mkdir($d2, 0777) or return -1;
+                }
                 $rtnVal = 1;
             }
@@ -2447,17 +3366,27 @@
 #------------------------------------------------------------------------------
 # Copy file attributes from one file to another
-# Inputs: 0) source file name, 1) destination file name
+# Inputs: 0) ExifTool ref, 1) source file name, 2) destination file name
 # Notes: eventually add support for extended attributes?
-sub CopyFileAttrs($$)
-{
-    my ($src, $dst) = @_;
+sub CopyFileAttrs($$$)
+{
+    my ($self, $src, $dst) = @_;
     my ($mode, $uid, $gid) = (stat($src))[2, 4, 5];
-    eval { chmod($mode & 07777, $dst) } if defined $mode;
-    eval { chown($uid, $gid, $dst) } if defined $uid and defined $gid;
-}
-
-#------------------------------------------------------------------------------
-# Get new file name
-# Inputs: 0) existing name, 1) new name
+    # copy file attributes unless we already set them
+    if (defined $mode and not defined $self->GetNewValue('FilePermissions')) {
+        eval { chmod($mode & 07777, $dst) };
+    }
+    my $newUid = $self->GetNewValue('FileUserID');
+    my $newGid = $self->GetNewValue('FileGroupID');
+    if (defined $uid and defined $gid and (not defined $newUid or not defined $newGid)) {
+        defined $newGid and $gid = $newGid;
+        defined $newUid and $uid = $newUid;
+        eval { chown($uid, $gid, $dst) };
+    }
+}
+
+#------------------------------------------------------------------------------
+# Get new file path name
+# Inputs: 0) existing name (may contain directory),
+#         1) new file name, new directory, or new path (dir+name)
 # Returns: new file path name
 sub GetNewFileName($$)
@@ -2478,5 +3407,5 @@
 # Inputs: 0) hash reference (keys are tag keys), 1) tag name
 # Returns: next available tag key
-sub NextTagKey($$)
+sub NextFreeTagKey($$)
 {
     my ($info, $tag) = @_;
@@ -2501,8 +3430,12 @@
         $val = $1;    # was unknown
         if ($val =~ /^0x([\da-fA-F]+)$/) {
+            # disable "Hexadecimal number > 0xffffffff non-portable" warning
+            local $SIG{'__WARN__'} = sub { };
             $val = hex($val);   # convert hex value
         }
     } else {
-        my $qval = quotemeta $val;
+        my $qval = $val;
+        $qval =~ s/\s+$//;      # remove trailing whitespace
+        $qval = quotemeta $qval;
         my @patterns = (
             "^$qval\$",         # exact match
@@ -2533,5 +3466,11 @@
         unless ($found) {
             # call OTHER conversion routine if available
-            $val = $$conv{OTHER} ? &{$$conv{OTHER}}($val,1,$conv) : undef;
+            if ($$conv{OTHER}) {
+                local $SIG{'__WARN__'} = \&SetWarning;
+                undef $evalWarning;
+                $val = &{$$conv{OTHER}}($val,1,$conv);
+            } else {
+                $val = undef;
+            }
             $multi = 1 if $matches > 1;
         }
@@ -2543,12 +3482,13 @@
 #------------------------------------------------------------------------------
 # Return true if we are deleting or overwriting the specified tag
-# Inputs: 0) new value hash reference
-#         1) optional tag value (before RawConv) if deleting specific values
+# Inputs: 0) ExifTool object ref, 1) new value hash reference
+#         2) optional tag value (before RawConv) if deleting specific values
 # Returns: >0 - tag should be overwritten
 #          =0 - the tag should be preserved
 #          <0 - not sure, we need the value to know
-sub IsOverwriting($;$)
-{
-    my ($nvHash, $val) = @_;
+# Notes: $$nvHash{Value} is updated with the new value when shifting a value
+sub IsOverwriting($$;$)
+{
+    my ($self, $nvHash, $val) = @_;
     return 0 unless $nvHash;
     # overwrite regardless if no DelValues specified
@@ -2566,9 +3506,9 @@
         undef $evalWarning;
         if (ref $conv eq 'CODE') {
-            $val = &$conv($val, $$nvHash{Self});
+            $val = &$conv($val, $self);
         } else {
-            my $self = $$nvHash{Self};
+            my ($priority, @grps);
             my $tag = $$tagInfo{Name};
-            #### eval RawConv ($self, $val, $tag, $tagInfo)
+            #### eval RawConv ($self, $val, $tag, $tagInfo, $priority, @grps)
             $val = eval $conv;
             $@ and $evalWarning = $@;
@@ -2576,12 +3516,44 @@
         return -1 unless defined $val;
     }
-    # apply time shift if necessary
+    # do not overwrite if only creating
+    return 0 if $$nvHash{CreateOnly};
+    # apply time/number shift if necessary
     if (defined $shift) {
+        my $shiftType = $$tagInfo{Shift};
+        unless ($shiftType and $shiftType eq 'Time') {
+            unless (IsFloat($val)) {
+                # do the ValueConv to try to get a number
+                my $conv = $$tagInfo{ValueConv};
+                if (defined $conv) {
+                    local $SIG{'__WARN__'} = \&SetWarning;
+                    undef $evalWarning;
+                    if (ref $conv eq 'CODE') {
+                        $val = &$conv($val, $self);
+                    } elsif (not ref $conv) {
+                        #### eval ValueConv ($val, $self)
+                        $val = eval $conv;
+                        $@ and $evalWarning = $@;
+                    }
+                    if ($evalWarning) {
+                        $self->Warn("ValueConv $$tagInfo{Name}: " . CleanWarning());
+                        return 0;
+                    }
+                }
+                unless (defined $val and IsFloat($val)) {
+                    $self->Warn("Can't shift $$tagInfo{Name} (not a number)");
+                    return 0;
+                }
+            }
+            $shiftType = 'Number';  # allow any number to be shifted
+        }
         require 'Image/ExifTool/Shift.pl';
-        my $err = ApplyShift($$tagInfo{Shift}, $shift, $val, $nvHash);
+        my $err = $self->ApplyShift($shiftType, $shift, $val, $nvHash);
         if ($err) {
-            $nvHash->{Self}->Warn("$err when shifting $$tagInfo{Name}");
+            $self->Warn("$err when shifting $$tagInfo{Name}");
             return 0;
         }
+        # ensure that the shifted value is valid and reformat if necessary
+        my $checkVal = $self->GetNewValue($nvHash);
+        return 0 unless defined $checkVal;
         # don't bother overwriting if value is the same
         return 0 if $val eq $$nvHash{Value}[0];
@@ -2597,13 +3569,4 @@
 
 #------------------------------------------------------------------------------
-# Return true if we are creating the specified tag even if it didn't exist before
-# Inputs: 0) new value hash reference
-# Returns: true if we should add the tag
-sub IsCreating($)
-{
-    return $_[0]{IsCreating};
-}
-
-#------------------------------------------------------------------------------
 # Get write group for specified tag
 # Inputs: 0) new value hash reference
@@ -2621,5 +3584,5 @@
 {
     my ($self, $tagInfo, $writeGroup) = @_;
-    return $writeGroup unless $writeGroup =~ /^(MakerNotes|XMP|Composite)$/;
+    return $writeGroup unless $writeGroup =~ /^(MakerNotes|XMP|Composite|QuickTime)$/;
     return $self->GetGroup($tagInfo, 1);
 }
@@ -2628,11 +3591,14 @@
 # Get new value hash for specified tagInfo/writeGroup
 # Inputs: 0) ExifTool object reference, 1) reference to tag info hash
-#         2) Write group name, 3) Options: 'delete' or 'create'
+#         2) Write group name, 3) Options: 'delete' or 'create' new value hash
+#         4) optional ProtectSaved value, 5) true if we are deleting a value
 # Returns: new value hash reference for specified write group
 #          (or first new value hash in linked list if write group not specified)
-sub GetNewValueHash($$;$$)
+# Notes: May return undef when 'create' is used with ProtectSaved
+sub GetNewValueHash($$;$$$$)
 {
     my ($self, $tagInfo, $writeGroup, $opts) = @_;
-    my $nvHash = $self->{NEW_VALUE}{$tagInfo};
+    return undef unless $tagInfo;
+    my $nvHash = $$self{NEW_VALUE}{$tagInfo};
 
     my %opts;   # quick lookup for options
@@ -2642,14 +3608,24 @@
     if ($writeGroup) {
         # find the new value in the list with the specified write group
-        while ($nvHash and $nvHash->{WriteGroup} ne $writeGroup) {
-            $nvHash = $nvHash->{Next};
+        while ($nvHash and $$nvHash{WriteGroup} ne $writeGroup) {
+            # QuickTime and All are special cases because all group1 tags may be updated at once
+            last if $$nvHash{WriteGroup} =~ /^(QuickTime|All)$/;
+            # replace existing entry if WriteGroup is 'All' (avoids confusion of forum10349)
+            last if $$tagInfo{WriteGroup} and $$tagInfo{WriteGroup} eq 'All';
+            $nvHash = $$nvHash{Next};
         }
     }
     # remove this entry if deleting, or if creating a new entry and
     # this entry is marked with "Save" flag
-    if (defined $nvHash and ($opts{'delete'} or
-        ($opts{'create'} and $nvHash->{Save})))
-    {
-        if ($opts{'delete'}) {
+    if (defined $nvHash and ($opts{'delete'} or ($opts{'create'} and $$nvHash{Save}))) {
+        my $protect = (defined $_[4] and defined $$nvHash{Save} and $$nvHash{Save} > $_[4]);
+        # this is a bit tricky:  we want to add to a protected nvHash only if we
+        # are adding a conditional delete ($_[5] true or DelValue with no Shift)
+        # or accumulating List items (NoReplace true)
+        if ($protect and not ($opts{create} and ($$nvHash{NoReplace} or $_[5] or
+            ($$nvHash{DelValue} and not defined $$nvHash{Shift}))))
+        {
+            return undef;   # honour ProtectSaved value by not writing this tag
+        } elsif ($opts{'delete'}) {
             $self->RemoveNewValueHash($nvHash, $tagInfo);
             undef $nvHash;
